package io.github.null2264.tsukumogami.core

import dev.kord.core.Kord
import io.github.null2264.tsukumogami.core.module.BotModule
import kotlin.reflect.KFunction

class BotHolder internal constructor(
    val bot: Bot
) {

    internal val prefixes = mutableListOf<String>()
    var token: String
        get() = bot.token
        set(value) {
            bot.token = value
        }

    fun modules(vararg modules: BotModule) {
        modules.forEach(bot::addModule)
    }

    fun prefixes(vararg prefixes: String) {
        prefixes.forEach(bot::addPrefix)
    }
}

fun bot(clazz: KFunction<Bot> = ::Bot, declaration: BotHolder.() -> Unit): Bot {
    val bot = clazz.call()
    val holder = BotHolder(bot)
    declaration(holder)
    return holder.bot
}
