package io.github.null2264.tsukumogami.core

import dev.kord.core.behavior.channel.createMessage
import dev.kord.core.entity.Message
import dev.kord.rest.builder.message.AllowedMentionsBuilder
import dev.kord.rest.builder.message.allowedMentions
import io.github.null2264.tsukumogami.core.commands.Command

class Context(
    private val bot: Bot,
    private val message: Message,
    /**
     * The prefix that used to invoke the command
     */
    val prefix: String?,
    /**
     * Potential command name and/or arguments
     */
    val candidate: List<String>?,
) {
    val author get() = message.author

    /**
     * The command that currently being invoked
     */
    var command: Command? = null

    suspend fun send(content: String) = message.channel.createMessage(content)

    suspend fun reply(content: String, mentionsAuthor: Boolean = false) = message.channel.createMessage {
        this.content = content
        messageReference = message.id
        if (!mentionsAuthor)
            allowedMentions {
                AllowedMentionsBuilder().repliedUser
            }
    }

    suspend fun typing() = message.channel.type()
}
