package io.github.null2264.tsukumogami.core.commands

import io.github.null2264.tsukumogami.core.commands.converters.Converter

abstract class Arguments {
    val args = mutableListOf<Argument<*>>()

    fun <R : Any> args(
        name: String,
        converter: Converter<R>
    ): Converter<R> {
        args.add(Argument(name, converter))

        return converter
    }

    suspend fun parse(value: String) {
        args.forEach { arg ->
            arg.converter.parse(value)
        }
    }
}
