package io.github.null2264.tsukumogami.core.commands

import io.github.null2264.tsukumogami.core.Context

class Group(
    name: String,
    alias: Set<String>,
    description: String,
) :
    IGroup,
    Command(
        name,
        alias,
        description,
        ::EmptyArguments,
        { _, _ -> /* No handler for group to match the behaviour of Discord's slash command */ },
    ) {

    override val allCommands: MutableMap<String, Command> = mutableMapOf()

    override suspend fun invoke(context: Context) {
        val command = allCommands["TODO"] ?: return
        context.command = command
        command.invoke(context)
    }
}
