package io.github.null2264.tsukumogami.core.commands.converters

import io.github.null2264.tsukumogami.core.commands.Argument
import io.github.null2264.tsukumogami.core.commands.Arguments
import kotlin.reflect.KProperty

abstract class Converter<OutputType: Any?> {
    lateinit var argumentObj: Argument<OutputType>

    abstract var parsed: OutputType

    abstract suspend fun parse(input: String): OutputType

    operator fun getValue(thisRef: Arguments, property: KProperty<*>): OutputType {
        return parsed
    }
}
